program Dipintegrator_3D_2
  !
  !  <vesuvio.H Ungrad.x > height.H
  !
  use sep
  !use dipinteg_3D
  !use dipinteg_3D_slice
  !  use igrad3_period 
  use ztrans_mod
  use dipinteg_3D_2
  use triangle
  use igrad1
  use igrad2_2d
  use igrad2_3d
  use igrad3
  use icai1
  use igrad2
  use dottest
  use igrad3_epst
  use fault_weight
  use solver_smp_mod
  use weight_solver

  ! use triangle1

  implicit none
  integer 	                             :: n1, n2, n3, iter,mirror,bounds,slice,esize,stat1,iv,ik
  integer                                    ::padlength,it,ix,iy,ir,dist,taper_len,niter,ip
  integer                                    ::linear_niter,movie_index,use_wt
  integer                                    ::ref_2,ref_3
  real                                       :: q,eps_t,eps_h,pi_var,eps_r,wt_iter
  real                                       ::res_scale,res_val,last_res
  complex, dimension (:,:,:),   allocatable  :: data_in
  complex, dimension (:,:,:),   allocatable    ::ztrans,ztrans2
  real,    dimension (:),     allocatable    :: cos_wt,resid,rand_vec,rt_full
  real,    dimension(:),pointer              ::rt,hh,dtau,tau,tau_1st,tau_2nd,rt_new
  real,    dimension (:,:),     allocatable  ::hh_2D
  real,    dimension (:,:),     allocatable  ::tau_2D
  real,    dimension (:,:,:),   allocatable  :: data_amp,data_phz,data_real
  real,    dimension (:,:,:),   allocatable  :: data_imag,px,py,px_mirr,px_new
  real,    dimension (:,:,:),   allocatable  :: py_mirr,hh_3D
  real,    dimension (:,:,:),   allocatable  :: hh_3D_trun,tau_3D,res_3D,rt_3D
  real,    dimension (:,:,:,:),   allocatable  ::ww_3D
  !TEMPORY PTERM STUFF
  real,    dimension (:,:), allocatable      ::p_sqr,p_sqr_dtau,p_sqr_dtau_sm,pterm_cor
  real,    dimension(:),pointer              ::rt_adj,pterm_cor_1D,filter,ww,res_div,res_rev
  real,    dimension(:),allocatable           ::ww_slice
  integer, dimension (2)                :: n, rect
  real,    dimension  (2)   :: dot1,dot2
  real                                 ::upwt,downwt,p_tau_x,p_tau_y
  integer                                ::tau_1,tau_2
  real                                 ::dtau_dx,dtau_dy,shift_var
  real,    dimension (:,:), allocatable      ::px_2D_new,py_2D_new
  real,    dimension (:,:,:),   allocatable  ::px_3D,py_3D
  call sep_init ()
  ! call from_history (n1,n2,n3,esize=4)
  !  call from_history ("esize",esize,8) 
  call from_param("eps_t",eps_t,1.)
  call from_param("eps_h",eps_h,1.)
  call from_param("eps_r",eps_r,1.)
  call from_param("mirror",mirror,1) 
  call from_param("bounds",bounds,2)
  call from_param("slice",slice,0)
  call from_param("ref_2",ref_2,1)
  call from_param("ref_3",ref_3,1)
  call from_aux ("dipx", n1,n2,n3,esize=4)
  write(0,*) 'n1,n2,n3',n1,n2,n3
  call from_param("niter",niter,1)
  call from_param("linear_niter",linear_niter,100)
  call from_param("wt_iter",wt_iter,1.)

  !  call igrad2_3d_init(n1,n2,n3,eps_h)
  !  call dot_test (igrad2_3d_lop,100,300,dot1,dot2)


  ! READ IN DATA
  select case(slice)
  case(0) 
     ! 3D full volume integration
     if (n3>1.and.n2>1.and.n1>1) then
        allocate(px(n1,n2,n3),py(n1,n2,n3))
        call sep_read(px,"dipx")
        call sep_read(py,"dipy")
        write(0,*) 'READ IN THE DIPS'
!!$        px(1:,12:27,24)=1. ! DELETE ME!!!!!!
        !  px(1:,23,25)=-20. ! DELETE ME!!!!!!

        !  pz=1. ! set to 1's
        ! allocate(ztrans(n1,2*n2,2*n3))


        ! call z_trans(n1,2*n2,2*n3,eps_t,eps_h,ztrans)

        ! FLATTEN TIME SLICE
!!$     else if (n3==1.and.n1>1.and.n2>1) then! 2D integration----1 time slice at a time
!!$        allocate(data_in(n1,n2,1),px(n1,n2,1),py(n1,n2,1))
!!$        bounds=4
!!$        call sep_read (data_in) 
!!$        px=real(data_in)  ! x direction dip
!!$        py=aimag(data_in)  ! y direction dip
!!$        call z_trans(1,2*n2,2*n3,1.,1.,ztrans)


        ! 2D VERTICAL SECTION
     else if (n3==1.and.n1>1.and.n2>1) then
        write(0,*) 'THIS IS A 2D SECTION'
        !        bounds=2
        allocate(ztrans(n1,2*n2,n3),px(n1,n2,n3))

        call z_trans(n1,2*n2,1,eps_t,0.,ztrans)

!!$
!!$        call sep_write (real(ztrans),"test")
!!$        call to_history ("n1",   n1,"test")
!!$        call to_history ("n2",   n2*2,"test")
        !     stop
     else 
        write(0,*) 'error: do you have the right dimensions?'
        call exit(0)
     end if

     ! IF BIG VOLUME AND WANT TO DO ONE SLICE AT A TIME
  case(1) ! IF BIG VOLUME AND WANT TO DO ONE SLICE AT A TIME
     allocate(data_in(n1,n2,1),px(n1,n2,1),py(n1,n2,1))
     bounds=5
     ! allocate(ztrans(2*n1,2*n2,1))
     ! call z_trans(2*n1,2*n2,1,1.,0.,ztrans)

  end select






  ! write(0,*) 'about to make mirrors'
  ! MAKE MIRRORS

  ! allocate(pz_mirr(n1,n2*2,n3*2))
  ! pz_mirr=0.


  !  rt(1:n1*n2*2*n3*2)=reshape(pz_mirr,(/size(pz_mirr)/))
  !  deallocate(pz_mirr)

  select case(bounds)
  case(0)
     allocate(ztrans(n1,2*n2,2*n3))
     call z_trans(n1,2*n2,2*n3,eps_t,eps_h,ztrans)
     allocate( rt( n1*n2*n3*2),rt_new(n1*n2*n3*2))
     rt=0.
     rt(1:n1*n2*n3)=reshape(px,(/size(px)/))

     deallocate(px)
     rt(n1*n2*n3+1:2*n1*n2*n3)=reshape(py,(/size(py)/))
     deallocate(py)
     allocate(dtau(n1*n2*n3),tau(n1*n2*n3),ww(n1*n2*n3*2),tau_3D(n1,n2,n3),res_3D(n1,n2,n3))

     allocate(res_div(n1*n2*n3),res_rev(n1*n2*n3*2),ww_3D(n1,n2,n3,2))
     allocate(rt_3D(n1,n2,2*n3))

     tau=0.
!!$
!!$     tau_3D=reshape(tau,(/n1,n2,n3/))
!!$     do iv=1,n1
!!$        do ik=1,15
!!$           tau_3D(iv,ik+11,24)=ik ! DELETE ME!!!!!!
!!$        enddo
!!$     enddo
!!$     tau=reshape(tau_3D,(/n1*n2*n3/))
!!$

     dtau=0.
     ww=1.
     use_wt=1
     if (exist_file("wt_in")) then
        call sreed("wt_in",ww,4*n1*n2*n3*2)
        write(0,*) 'READ IN WEIGHT'
        use_wt=1
        rt=rt*ww
     end if
     rt_new=rt
     movie_index=0.

     call igrad2_3d_init(n1,n2,n3,1.)
     do iter=1,niter


        ! DELETE SECTION
!!$        if (iter>10) then
!!$           rt_3D=reshape(rt_new,(/n1,n2,n3*2/))
!!$           rt_3D(1:,23:26,25)=-20. ! DELETE ME!!!!!!           rt_new=reshape(rt_3D,(/n1*n2*n3*2/))
!!$           rt_new=reshape(rt_3D,(/n1*n2*n3*2/))
!!$           where (ww_3D<.5) ww_3D=0.
!!$ww_3D(1:,23,1:,1)=0.
!!$    ww_3D(1:,1:,1:,2)=ww_3D(1:,1:,1:,1)
!!$           ww_3D(1:,23,24,1)=1. ! DELETE ME!!!!!!
!!$           ww=reshape(ww_3D,(/n1*n2*n3*2/))
!!$           rt_new=rt_new*ww
!!$        end if
        write(0,*) 'min dip',minval(rt_new)
        call dipintegrate_3D (rt_new,dtau,eps_t,eps_h,n1,n2,n3,ztrans) 
!!$   if  (iter<=10) tau=0.
        write(0,*) 'maximum dtau',maxval(dtau)
        write(0,*) 'minimum dtau',minval(dtau)

        tau=tau+dtau
        write(0,*) maxval(px_new)  



        call correct_dip_3D  (tau,rt,rt_new,n1,n2,n3,ref_2,ref_3)
        if (real(iter)/wt_iter-floor(real(iter)/wt_iter)<.01.and.use_wt==1) then
           write(0,*) 'REWEIGHTING'
           !    if (iter<=10) then
           ww=1/(1+rt_new**2/eps_r**2)**2
           ww_3D=reshape(ww,(/n1,n2,n3,2/))
           !   end if
!!$
!!$           ww_3D(1:,23,24)=.1*iter ! DELETE ME!!!!!!
!!$           ww=reshape(ww_3D,(/n1*n2*n3*2/))

           ! another weight 
           res_rev(1:n1*n2*n3)=rt_new(n1*n2*n3+1:2*n1*n2*n3)
           res_rev(n1*n2*n3+1:2*n1*n2*n3)=rt_new(1:n1*n2*n3)
           stat1=igrad2_3d_lop(.true.,.false.,res_div,res_rev)
!!$           ww(1:n1*n2*n3)=1/(1+res_div**2/eps_r**2)**2
!!$           ww(n1*n2*n3+1:n1*n2*n3*2)=ww(1:n1*n2*n3)

           tau_3D=reshape(tau,(/n1,n2,n3/))
           res_3D=reshape(rt_new(1:n1*n2*n3),(/n1,n2,n3/))
           movie_index=movie_index+1

           call sep_write (tau_3D(1:,1:,nint(1.*real(n3)/2.)),"mod_movie")
           !     call sep_write (res_3D(1:,1:,nint(5.*real(n3)/6.)),"res_movie")
           call sep_write (res_3D(1:,1:,nint(1.*real(n3)/2.)),"res_movie")
           call sep_write (ww_3D(1:,1:,nint(1.*real(n3)/2.),1),"wt_movie")
           !        call sep_write (rt_new,"res_cube_movie")
           !   tau=0.
        end if
        write(0,*) 'unweighted averge abs dip',sum(abs((rt_new)))/(n1*n2*n3)
        rt_new=rt_new*ww
        write(0,*) 'weighted averge abs dip',sum(abs((rt_new)))/(n1*n2*n3)
        write(0,*) 'iter',iter,'residual',dot_product(rt_new,rt_new)
     end do

     call to_history ("n1",   n1)
     call to_history ("n2",   n2)
     call to_history ("n3",   n3)    
     call to_history ("esize",4)
     call sep_write (tau) 

     call sep_write  (ww           ,"wt_out") 
     call to_history ("n1",   n1   ,"wt_out")
     call to_history ("n2",   n2   ,"wt_out")
     call to_history ("n3",   n3*2 ,"wt_out")    
     call to_history ("esize",4    ,"wt_out")
!!$
     call sep_write (res_div,"res_div") 
     call to_history ("n1",   n1,"res_div")
     call to_history ("n2",   n2,"res_div")
     call to_history ("n3",   n3,"res_div")    
     call to_history ("esize",4,"res_div")

     call to_history ("n1",   n1,"mod_movie")
     call to_history ("n2",   n2,"mod_movie")
     call to_history ("n3",   movie_index,"mod_movie")    
     call to_history ("esize",4,"mod_movie")

     call to_history ("n1",   n1,"res_movie")
     call to_history ("n2",   n2,"res_movie")
     call to_history ("n3",   movie_index,"res_movie")    
     call to_history ("esize",4,"res_movie")

     call to_history ("n1",   n1,"wt_movie")
     call to_history ("n2",   n2,"wt_movie")
     call to_history ("n3",   movie_index,"wt_movie")    
     call to_history ("esize",4,"wt_movie")

     call to_history ("n1",   n1,"resid")
     call to_history ("n2",   n2,"resid")
     call to_history ("n3",   n3*2,"resid")    
     call to_history ("esize",4,"resid")
     call sep_write (rt_new,"resid") 

     call to_history ("n1",   n1,"res_cube_movie")
     call to_history ("n2",   n2,"res_cube_movie")
     call to_history ("n3",   n3*2,"res_cube_movie")
     call to_history ("n4", movie_index  ,"res_cube_movie")
     call to_history ("esize",4,"res_cube_movie")

     !
     call sep_close()
     call exit (0)
  case(1) ! 3D using conjagate gradients
     !    allocate(ztrans(n1,2*n2,2*n3))
     !    call z_trans(n1,2*n2,2*n3,eps_t,eps_h,ztrans)
     allocate( rt( n1*n2*n3*2),rt_new(n1*n2*n3*2))
     rt=0.
     rt(1:n1*n2*n3)=reshape(px,(/size(px)/))
     deallocate(px)
     rt(n1*n2*n3+1:2*n1*n2*n3)=reshape(py,(/size(py)/))
     deallocate(py)
     allocate(dtau(n1*n2*n3),tau(n1*n2*n3),ww(n1*n2*n3*2),tau_3D(n1,n2,n3),res_3D(n1,n2,n3))
     if (exist_file("wt_in")) then
        call sreed("wt_in",ww,4*n1*n2*n3*2)
        write(0,*) 'READ IN WEIGHT'
        use_wt=0
        rt=rt*ww
     end if

     rt_new=rt
     tau=0.
     dtau=0.
     ww=1.
     movie_index=0.
     !     call igrad2_2d_init(n1,n2)
     call igrad2_3d_init(n1,n2,n3,1.)
     !    call igrad3_init(n1,n2,n3)
     !    call dot_test (igrad3_lop,100,300,dot1,dot2)

     !     call dot_test (igrad2_3d_lop,100,200,dot1,dot2)


     do iter=1,niter
        call fault_w_init(ww)
        !  call dipintegrate_3D (rt_new,dtau,eps_t,eps_h,n1,n2,n3,ztrans) 
        call solver_smp(dtau, rt_new,igrad2_3d_lop,cgstep,linear_niter,verb=.true.,Wop=fault_w_oper)
        !call solver(igrad2_3d_lop,solver_smp,dtau,rt_new,linear_niter,3,4,ww)
        call cgstep_close ()
        tau=tau+dtau
        write(0,*) maxval(px_new)  

        call correct_dip_3D  (tau,rt,rt_new,n1,n2,n3,ref_2,ref_3)
        !   if (real(iter)/wt_iter-floor(real(iter)/wt_iter)<.01) ww=1/(1+rt_new**2/eps_r**2)**2
        if (real(iter)/wt_iter-floor(real(iter)/wt_iter)<.01) then
           ww=1/(1+rt_new**2/eps_r**2)**2
           tau_3D=reshape(tau,(/n1,n2,n3/))
           res_3D=reshape(rt_new(1:n1*n2*n3),(/n1,n2,n3/))
           movie_index=movie_index+1           
           call sep_write (tau_3D(1:,1:,nint(5.*real(n3)/6.)),"mod_movie")
           call sep_write (res_3D(1:,1:,nint(5.*real(n3)/6.)),"res_movie")
           tau=0.
        end if
        !  rt_new=rt_new*ww
        write(0,*) 'iter',iter,'residual',dot_product(rt_new,rt_new)
     end do

     call to_history ("n1",   n1)
     call to_history ("n2",   n2)
     call to_history ("n3",   n3)    
     call to_history ("esize",4)
     call sep_write (tau) 

     call sep_write (ww,"wt_out") 
     call to_history ("n1",   n1,"wt_out")
     call to_history ("n2",   n2,"wt_out")
     call to_history ("n3",   n3*2,"wt_out")    
     call to_history ("esize",4,"wt_out")

     call to_history ("n1",   n1,"mod_movie")
     call to_history ("n2",   n2,"mod_movie")
     call to_history ("n3",   movie_index,"mod_movie")    
     call to_history ("esize",4,"mod_movie")

     call to_history ("n1",   n1,"res_movie")
     call to_history ("n2",   n2,"res_movie")
     call to_history ("n3",   movie_index,"res_movie")    
     call to_history ("esize",4,"res_movie")

     call to_history ("n1",   n1,"resid")
     call to_history ("n2",   n2,"resid")
     call to_history ("n3",   n3*2,"resid")    
     call to_history ("esize",4,"resid")
     call sep_write (rt_new,"resid") 
     !
     call sep_close()
     call exit (0)




  case(2)  ! 2D integration----1 slice at a time

     call to_history ("n1",   n1)
     call to_history ("n2",   n2)
     call to_history ("n3",   n3)    
     call to_history ("esize",4)
     call to_history ("d1",   1)
     call to_history ("d2",   1)
     call to_history ("d3",   1)    
     call to_history ("o1",   0.)
     call to_history ("o2",   0.)
     call to_history ("o3",   0.)   
     allocate(dtau(n1*n2*n3),tau(n1*n2*n3))
     allocate(hh_2D(n1,n2),px_new(n1,n2,n3))
     allocate(resid(n1*n2*n3))

     dtau=0.
     tau=0.

     do it=1,n3
        call sep_read(px,"dipx")
        px_new=px
        write(0,*) maxval(px),minval(px),sum(px)/size(px)
        rt=0.
        hh=0.
        do iter=1,niter
           allocate( rt( n1*n2))
           rt(1:n1*n2)=reshape(px_new,(/size(px)/))

           call dipintegrate_2D (rt,dtau,eps_t,n1,n2,ztrans) 

           tau=tau+dtau
           write(0,*) maxval(px_new)   
           call correct_dip_2D  (tau,px,px_new,ref_2)
           write(0,*) maxval(px_new)   
           !  call dipintegrate_3D_slice (rt,hh,eps_t,eps_h,1,n1,n2,ztrans)

           resid=reshape(px_new,(/n1*n2*n3/))
           write(0,*) 'iter',iter,'residual',dot_product(resid,resid)
        end do

        hh_2D=reshape(tau,(/n1,n2/))


        call sep_write (hh_2D(1:n1,1:n2)) !-sum(hh_2D(1:n1,1:n2))/(n1*n2)) 
     end do

     !DELETE !!!
     do it=1,n1
        hh_2D(it,1:)=it
     end do
     call sep_write (hh_2D(1:n1,1:n2),"junk")
     call to_history ("n1",   n1,"junk")
     call to_history ("n2",   n2,"junk")
     !DELETE !!!

  case(3)  ! FULL EQUATION

     call to_history ("n1",   n1)
     call to_history ("n2",   n2)
     call to_history ("n3",   n3)    
     call to_history ("esize",4)
     call to_history ("d1",   1)
     call to_history ("d2",   1)
     call to_history ("d3",   1)    
     call to_history ("o1",   0.)
     call to_history ("o2",   0.)
     call to_history ("o3",   0.)   
     allocate(dtau(n1*n2*n3),tau(n1*n2*n3))
     allocate(hh_2D(n1,n2),px_new(n1,n2,n3))
     allocate(resid(n1*n2*n3))

     dtau=0.
     tau=0.
     call igrad2_2d_init(n1,n2)



     do it=1,n3
        call sep_read(px,"dipx")
        allocate(rand_vec(n2)) 
        call random_number(rand_vec)
        rand_vec=1*(rand_vec-.5)
!!$do ix=1,n2
!!$   px(1:,ix,1)=px(1:,ix,1)*rand_vec(ix)
!!$end do
        do ix=1,n2
           do ip=1,n1
              !            px(ip,ix,1)=(0.000001*(ip**3))!+rand_vec(ix) !(.0005*ip**2)+rand_vec(ix)
              px(ip,ix,1)=cos(real(ip)/50.)!(0.000001*(ip**2))
              !    write(0,*) cos(real(ip)),ip
              !    if (px(ip,ix,1)>8.)  write(0,*) 'too steep', px(ip,ix,1),it,ix
              !   px(ip,ix,1)=(.005*ip) !+rand_vec(ix)
              !      if (px(ip,ix,1)>6.) px(ip,ix,1)=6. ! write(0,*) 'too steep', px(ip,ix,1),it,ip
           end do
        end do
        call to_history("n1",n1,"model_px"); call to_history("n2",n2,"model_px")
        call to_history("n3",n3,"model_px")
!!$  call to_history("d1",d1,"model_px"); call to_history("d2",d2,"model_px")
!!$  call to_history("d3",d3,"model_px")
!!$  call to_history("o1",o1,"model_px"); call to_history("o2",02,"model_px")
!!$  call to_history("o3",o3,"model_px")
        call to_history("esize",4,"model_px")
        call sep_write(px,"model_px")



        px_new=px
        write(0,*) maxval(px),minval(px),sum(px)/size(px)
        rt=0.
        hh=0.


        ! CREATE PTERM
        allocate(p_sqr(n1,n2),p_sqr_dtau(n1,n2),p_sqr_dtau_sm(n1,n2),rt_adj(n1*n2),pterm_cor(n1,n2),pterm_cor_1D(n1*n2))
        pterm_cor=0.
        pterm_cor_1D=0.
        write(0,*) '1max/min',maxval(pterm_cor_1D),minval(pterm_cor_1D)
        ! p_sqr=reshape(px_new,(/size(px)/))
        p_sqr=px(1:,1:,1)*px(1:,1:,1)
        write(0,*) 'p_sqr',maxval(p_sqr),minval(p_sqr)
        do ix=1,n2
           stat1=igrad1_lop(.false.,.false.,p_sqr(1:,ix),p_sqr_dtau(1:,ix))
           !stat1=igrad1_lop(.true.,.false.,p_sqr_dtau(1:,ix),p_sqr(1:,ix))
        end do
        p_sqr_dtau=.5*p_sqr_dtau
        write(0,*) 'p_sqr_dtau',maxval(p_sqr_dtau),minval(p_sqr_dtau)
        rect(1)=10
        rect(2)=1
        n(1)=n1
        n(2)=n2

        ! SMOOTH PTERM

!!$        call triangle_init (60,n1) !70
!!$        do ix=1,n2
!!$           stat1 = triangle_lop (.false., .false., p_sqr_dtau(1:,ix), p_sqr_dtau_sm(1:,ix))
!!$           stat1 = triangle_lop (.false., .false., p_sqr_dtau_sm(1:,ix), p_sqr_dtau(1:,ix))
!!$           stat1 = triangle_lop (.false., .false., p_sqr_dtau(1:,ix), p_sqr_dtau_sm(1:,ix))
!!$           stat1 = triangle_lop (.false., .false., p_sqr_dtau_sm(1:,ix), p_sqr_dtau(1:,ix))
!!$           stat1 = triangle_lop (.false., .false., p_sqr_dtau(1:,ix), p_sqr_dtau_sm(1:,ix))
!!$        end do
!!$        call triangle_close()
!!$        call triangle_init (55,n2)!55
!!$        do ip=1,n1
!!$           stat1 = triangle_lop (.false., .false., p_sqr_dtau_sm(ip,1:), p_sqr_dtau(ip,1:))
!!$           stat1 = triangle_lop (.false., .false., p_sqr_dtau(ip,1:), p_sqr_dtau_sm(ip,1:))
!!$           stat1 = triangle_lop (.false., .false., p_sqr_dtau_sm(ip,1:), p_sqr_dtau(ip,1:))
!!$           stat1 = triangle_lop (.false., .false., p_sqr_dtau(ip,1:), p_sqr_dtau_sm(ip,1:))
!!$           stat1 = triangle_lop (.false., .false., p_sqr_dtau_sm(ip,1:), p_sqr_dtau(ip,1:))
!!$           stat1 = triangle_lop (.false., .false., p_sqr_dtau(ip,1:), p_sqr_dtau_sm(ip,1:))
!!$           stat1 = triangle_lop (.false., .false., p_sqr_dtau_sm(ip,1:), p_sqr_dtau(ip,1:))
!!$           stat1 = triangle_lop (.false., .false., p_sqr_dtau(ip,1:), p_sqr_dtau_sm(ip,1:))
!!$        end do
!!$
!!$        call triangle_close()
!!$        call triangle_init (10,n1)
!!$        do ix=1,n2
!!$           stat1 = triangle_lop (.false., .false., p_sqr_dtau_sm(1:,ix), p_sqr_dtau(1:,ix))
!!$           stat1 = triangle_lop (.false., .false., p_sqr_dtau(1:,ix), p_sqr_dtau_sm(1:,ix))
!!$           stat1 = triangle_lop (.false., .false., p_sqr_dtau_sm(1:,ix), p_sqr_dtau(1:,ix))
!!$           stat1 = triangle_lop (.false., .false., p_sqr_dtau(1:,ix), p_sqr_dtau_sm(1:,ix))
!!$        end do
!!$        p_sqr_dtau=p_sqr_dtau_sm

        allocate( rt( n1*n2))
        do iter=1,niter
           write(0,*) '1'
           rt(1:n1*n2)=reshape(px_new,(/size(px)/))
           write(0,*) '2'
           stat1=igrad2_2d_lop(.true.,.false.,rt_adj , rt)
           !   if (iter/=1)then
           write(0,*) '1'
           pterm_cor=0.
           call correct_div(tau,p_sqr_dtau,pterm_cor)
           ! call correct_div(tau,p_sqr,pterm_cor)
           write(0,*) '2'
           pterm_cor_1D=reshape(pterm_cor,(/size(pterm_cor_1D)/))
           !   end if

           write(0,*) '2max/min',maxval(pterm_cor_1D),minval(pterm_cor_1D)
           rt=rt_adj-n2*pterm_cor_1D  !130
           !rt=rt_adj-n2/2*pterm_cor_1D 
           call dipintegrate_full (rt,dtau,eps_t,n1,n2,ztrans) 

           tau=tau+dtau
           write(0,*) 'px_new',maxval(px_new) , minval(px_new) ,sum(px_new)
           write(0,*) 'tau',maxval(tau) , minval(tau) ,sum(tau)

           call correct_dip_2D  (tau,px,px_new,ref_2)
           write(0,*) maxval(px_new)  
           !  call dipintegrate_3D_slice (rt,hh,eps_t,eps_h,1,n1,n2,ztrans)

           resid=reshape(px_new,(/n1*n2*n3/))
           write(0,*) 'iter',iter,'residual',dot_product(resid,resid)
        end do

        hh_2D=reshape(tau,(/n1,n2/))


        call sep_write (hh_2D(1:n1,1:n2)) !-sum(hh_2D(1:n1,1:n2))/(n1*n2)) 

     end do

     write(0,*) 'finished integration'
     call sep_close()
     call exit (0)

  case(4)  ! 2D integration----1 slice at a time---using conjagate gradients

     call to_history ("n1",   n1)
     call to_history ("n2",   n2)
     call to_history ("n3",   n3)    
     call to_history ("esize",4)
     call to_history ("d1",   1)
     call to_history ("d2",   1)
     call to_history ("d3",   1)    
     call to_history ("o1",   0.)
     call to_history ("o2",   0.)
     call to_history ("o3",   0.)   
     allocate(dtau(n1*n2*n3),tau(n1*n2*n3))
     allocate(hh_2D(n1,n2),px_new(n1,n2,n3))
     allocate(resid(n1*n2*n3))

     dtau=0.
     tau=0.
     call igrad2_2d_init(n1,n2)

     do it=50,50 !1,n3
        call sep_read(px,"dipx")
        px_new=px
        write(0,*) maxval(px),minval(px),sum(px)/size(px)
        rt=0.
        hh=0.
        do iter=1,niter
           allocate( rt( n1*n2))
           rt(1:n1*n2)=reshape(px_new,(/size(px)/))

           !call dipintegrate_2D (rt,dtau,eps_t,n1,n2,ztrans) 
           call solver_smp(dtau, rt,igrad2_2d_lop,cgstep,linear_niter,verb=.true.)
           tau=tau+dtau        
           call correct_dip_2D  (tau,px,px_new,ref_2)     
           resid=reshape(px_new,(/n1*n2*n3/))
           write(0,*) 'iter',iter,'residual',dot_product(resid,resid)
        end do


        call sep_write(tau) 

     end do
  case(5)  ! 2D time slice integration---
     write(0,*) 'herea1'
     call to_history ("n1",   n1)
     call to_history ("n2",   n2)
     call to_history ("n3",   n3)    
     call to_history ("esize",4)
     call to_history ("d1",   1)
     call to_history ("d2",   1)
     call to_history ("d3",   1)    
     call to_history ("o1",   0.)
     call to_history ("o2",   0.)
     call to_history ("o3",   0.)   
     allocate(dtau(n1*n2*n3),tau(n1*n2*n3))
     allocate(hh_2D(n1,n2),px_new(n1,n2,n3))
     allocate(resid(n1*n2*n3),ww(n1*n2*n3*2))
     allocate( rt( n1*n2*2),rt_new(n1*n2*2))

     dtau=0.
     tau=0.
     call igrad2_init(n1,n2)

     do it=1,n3
        call sep_read(px,"dipx")
        call sep_read(py,"dipy")
        call sep_read(hh_2D,"ww")
        ww=1.
        !   ww(1:n1*n2) =reshape(hh_2D,(/size(hh_2D)/))

        !      write(0,*) maxval(px),minval(px),sum(px)/size(px)

        rt=0.
        hh=0.

        rt(1:n1*n2)        =reshape(px,(/size(px)/))
        rt(n1*n2+1:n1*n2*2)=reshape(py,(/size(py)/))
        rt_new=rt

        do iter=1,niter
           !   allocate( rt( n1*n2))
           !  rt_new(1:n1*n2)=reshape(_new,(/size(px)/))

           call dipintegrate_timeslice (rt_new,dtau,n1,n2,ztrans) 
           !    call solver_smp(dtau, rt,igrad2_2d_lop,cgstep,linear_niter,verb=.true.)

           tau=tau+dtau   
           rt_new=-rt
           stat1=igrad2_lop(.false.,.true.,tau,rt_new) ! grad tau -p =r
           rt_new=-1*rt_new
           write(0,*) 'iter',iter

           !  write(0,*) 'n1,n2,n3',n1,n2,n3
           !dtau=0.
           !call correct_dip_3D(dtau,rt,rt_new,n3,n1,n2)  
           write(0,*) 'corrected dips'
           ww=1/(1+rt_new**2/eps_r**2)**2 !ww=1/((1+res**2)**.5/1.)
           !  rt_new=rt_new*ww

           !    call sep_read(ww(1:n1*n2),"park_2D.wt.H")
           !    call sep_read(ww(n1*n2+1:n1*n2*2),"park_2D.wt.H")
           !rt_new=rt
           rt_new=rt_new*ww
           !    resid=reshape(px_new,(/n1*n2*n3/))
           write(0,*) 'iter',iter,'residual',dot_product(rt_new,rt_new)
        end do


        call sep_write(tau) 

        call sep_write (ww,"wt_out") 
        call to_history ("n1",   n1,"wt_out")
        call to_history ("n2",   n2,"wt_out")
        call to_history ("n3",   n3*2,"wt_out")    
        call to_history ("esize",4,"wt_out")

        call sep_write (rt_new,"res") 
        call to_history ("n1",   n1,"res")
        call to_history ("n2",   n2,"res")
        call to_history ("n3",   n3*2,"res")    
        call to_history ("esize",4,"res")

     end do

  case(6) !one slice at a time

     allocate(ztrans(1,2*n2,2*n3))
     call z_trans(1,2*n2,2*n3,0.,eps_h,ztrans)
     allocate( rt( n2*n3*2),rt_new(n2*n3*2),tau_3D(n1,n2,n3),tau(n2*n3))
     allocate(dtau(n2*n3))
     allocate(rt_full(n1*n2*n3*2))
     allocate(tau_2D(n2,n3))
     allocate(px_2D_new(n2,n3),py_2D_new(n2,n3))
     rt_full(1:n1*n2*n3)        =reshape(px,(/n1*n2*n3/))
     rt_full(n1*n2*n3+1:n1*n2*n3*2)=reshape(py,(/n1*n2*n3/))
     allocate(px_3D(n1,n2,n3),py_3D(n1,n2,n3))
     allocate(ww(n2*n3*2),ww_3D(n1,n2,n3,2))
     px_3D=px
     py_3D=py 
     last_res=res_val
     ww=1.
     ww_3D=1.
     movie_index=0
     if (exist_file("wt_in")) then 
        write(0,*) 'READING IN WEIGHT'
        call sreed("wt_in",ww_3D,4*n1*n2*n3*1)
        px_3D=px_3D*ww_3D(1:,1:,1:,1)
        py_3D=py_3D*ww_3D(1:,1:,1:,1) 
        write(0,*) 'READ IN WEIGHT'
        use_wt=0
     end if

!!$     do it=50,50,1 !1,n1,1 
   do it=1,n1,1 

        write(0,*) 'grabbing slice',it,'of',n1,(real(it)/real(n1))*100.,'% complete'
        rt=0.
        hh=0.

        rt(1:n2*n3)        =reshape(px(it,1:,1:),(/n2*n3/))
        rt(n2*n3+1:n2*n3*2)=reshape(py(it,1:,1:),(/n2*n3/))
        rt_new=rt

        if (exist_file("wt_in")) then
           ww(1:n2*n3)        =reshape(ww_3D(it,1:,1:,1),(/n2*n3/))
           ww(n2*n3+1:2*n2*n3)=reshape(ww_3D(it,1:,1:,1),(/n2*n3/))  
           rt_new=rt_new*ww
        end if

        tau=0.
        res_scale=dot_product(rt_new,rt_new)
        res_scale=1.
        !     write(0,*) 'iter',0,'residual',1000*(dot_product(rt_new,rt_new)/res_scale)



        do iter=1,niter
           !   allocate( rt( n1*n2))
           !  rt_new(1:n1*n2)=reshape(_new,(/size(px)/))

           call dipintegrate_timeslice (rt_new,dtau,n2,n3,ztrans) 
           !    call solver_smp(dtau, rt,igrad2_2d_lop,cgstep,linear_niter,verb=.true.)
           tau=tau+dtau  
           !  call correct_dip_timeslice (tau,rt_full,rt_new,n1,n2,n3,ref_2,ref_3,it)

!!$
           tau_2D=reshape(tau,(/n2,n3/))

           do ix=1,n2-1
              do iy=1,n3-1
                 shift_var=tau_2D(ix,iy)-tau_2D(ref_2,ref_3)
                 tau_1=floor(it+shift_var)
                 tau_2=ceiling(it+shift_var)
                 upwt=it+shift_var-tau_1
                 downwt=1.-upwt
                 p_tau_x=downwt*px_3D(tau_1,ix,iy)+upwt*px_3D(tau_2,ix,iy)
                 p_tau_y=downwt*py_3D(tau_1,ix,iy)+upwt*py_3D(tau_2,ix,iy)

!!!$                 ! LINEAR ....DELETE
!!!$                  p_tau_x=px_3D(it,ix,iy)
!!!$                  p_tau_y=py_3D(it,ix,iy)

                 dtau_dx=tau_2D(ix+1,iy)-tau_2D(ix,iy)
                 dtau_dy=tau_2D(ix,iy+1)-tau_2D(ix,iy)

                 px_2D_new(ix,iy)=p_tau_x-dtau_dx
                 py_2D_new(ix,iy)=p_tau_y-dtau_dy

!!!$                 if (tau_1<1.or.tau_2>n1) then 
!!!$                    px_2D_new(ix,iy)=0. 
!!!$                    py_2D_new(ix,iy)=0.
!!!$                 end if

              end do
           end do
           !  end do

           rt_new(1:n2*n3)=reshape(px_2D_new,(/n2*n3/))
           rt_new(n2*n3+1:2*n2*n3)=reshape(py_2D_new,(/n2*n3/))

           if (exist_file("wt_in"))  rt_new=rt_new*ww

           ! deallocate(tau_2D,px_3D,py_3D)
           ! deallocate(px_2D_new,py_2D_new)



           !    resid=reshape(px_new,(/n1*n2*n3/))
           !        if (iter==1) res_scale=dot_product(rt_new,rt_new)
           res_val=1000*(dot_product(rt_new,rt_new)/res_scale)
           ! res_val=dot_product(rt_new,rt_new)
           write(0,*) 'iter',iter,'residual',res_val,maxval(rt_new),minval(rt_new)
           !  if (last_res-res_val<.001.and.iter>5.and.res_val<10.) exit
           last_res=res_val

           if (real(iter)/wt_iter-floor(real(iter)/wt_iter)<.01) then
              write(0,*) 'REWEIGHTING'
              ww=1/(1+rt_new**2/eps_r**2)**2
              !  ww_3D=reshape(ww,(/n1,n2,n3,2/))


              !    tau_3D=reshape(tau,(/n1,n2,n3/))
              !    res_3D=reshape(rt_new(1:n1*n2*n3),(/n1,n2,n3/))
              movie_index=movie_index+1

!!$              call sep_write (tau,"mod_movie")
!!$              !     call sep_write (res_3D(1:,1:,nint(5.*real(n3)/6.)),"res_movie")
!!$              call sep_write (rt_new(1:n2*n3),"res_movie")
!!$              call sep_write (ww(1:n2*n3),"wt_movie")
              !        call sep_write (rt_new,"res_cube_movie")
              ! tau=0.
           end if
           rt_new=rt_new*ww


        end do
        tau_3D(it,1:,1:)=reshape(tau,(/n2,n3/))


     end do
!!$     call sep_write(tau)  
  call sep_write(tau_3D) 

!!$     call to_history ("n1",   n2) 
!!$     call to_history ("n2",   n3)
!!$     call to_history ("n3",   1)   
!!$     call to_history ("esize",4)

     call to_history ("n1",   n1)
     call to_history ("n2",   n2)
     call to_history ("n3",   n3)     
     call to_history ("esize",4)



     call sep_write (ww,"wt_out") 
     call to_history ("n1",   n1,"wt_out")
     call to_history ("n2",   n2,"wt_out")
     call to_history ("n3",   n3*2,"wt_out")    
     call to_history ("esize",4,"wt_out")

     call to_history ("n1",   n2,"mod_movie")
     call to_history ("n2",   n3,"mod_movie")
     call to_history ("n3",   movie_index,"mod_movie")    
     call to_history ("esize",4,"mod_movie")

     call to_history ("n1",   n2,"wt_movie")
     call to_history ("n2",   n3,"wt_movie")
     call to_history ("n3",   movie_index,"wt_movie")    
     call to_history ("esize",4,"wt_movie")

     call to_history ("n1",   n2,"res_movie")
     call to_history ("n2",   n3,"res_movie")
     call to_history ("n3",   movie_index,"res_movie")    
     call to_history ("esize",4,"res_movie")

     call sep_write (rt_new,"res") 
     call to_history ("n1",   n1,"res")
     call to_history ("n2",   n2,"res")
     call to_history ("n3",   n3*2,"res")    
     call to_history ("esize",4,"res")



  end select




end program Dipintegrator_3D_2











